package com.muyu.server.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.domain.SysCarFaultMessage;
import com.muyu.server.mapper.SysCarFaultMessageMapper;
import com.muyu.server.service.SysCarFaultMessageService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 站内信 业务层
 * @author 袁子龙
 * @package: com.muyu.breakdown.service.impl
 * @name: SysCarFaultMessageServiceImpl
 * @date: 2024/9/22 14:36
 */
@Service
public class SysCarFaultMessageServiceImpl extends ServiceImpl<SysCarFaultMessageMapper, SysCarFaultMessage> implements SysCarFaultMessageService {

    /**
     * 查询故障消息列表
     * @param sysCarFaultMessage
     * @return
     */
    @Override
    public List<SysCarFaultMessage> selectSysCarFaultMessageList(SysCarFaultMessage sysCarFaultMessage) {
        LambdaQueryWrapper<SysCarFaultMessage> wrapper = new LambdaQueryWrapper<>();
        return baseMapper.selectList(wrapper);
    }

    /**
     * 查询故障消息列表中状态为1的故障消息
     * @return
     */
    @Override
    public List<SysCarFaultMessage> listStatusOnt( ) {
        return baseMapper.listStatusOnt();
    }

    /**
     * 查询故障消息列表中状态为2的故障消息
     * @return
     */
    @Override
    public List<SysCarFaultMessage> listStatusTwo( ) {
        return baseMapper.listStatusTwo();
    }
}
